/*********************************************************************
*项目名称:MG82F6B08_001_104-DEMO
*			测试板使用 MG82F6B08_001_104 SOP16_V11 EV Board (TH221A)
*			CpuCLK=8MHz, SysCLK=16MHz
*功能描述：
*			CPUCLK=SYSCLK (16MHz)
*			PCA时钟: SYSCLK
*			CH0(P30)/CH1(P33),CH2(P31)/CH3(P46)
*			2对互补,死区,中心对齐,分辨率为2000
*			PWM频率: 16MHz/(2000*2)=4KHz
*注意事项：
*
*建立时间:
*修改日志:
*    
*********************************************************************/
#define _MAIN_C

#include <Intrins.h>
#include <Absacc.h>

#include <Stdio.h>  // for printf

#include ".\include\REG_MG82F6B08_001_104.H"
#include ".\include\Type.h"
#include ".\include\API_Macro_MG82F6B08_001_104.H"
#include ".\include\API_Uart_BRGRL_MG82F6B08_001_104.H"


/*************************************************
*定义系统时钟SysClk (MAX.24MHz)
*可选: 
*	8000000,16000000
*	11059200,22118400
*************************************************/
#define MCU_SYSCLK		8000000
/*************************************************/
/*************************************************
*定义CPU时钟 CpuClk (MAX.16MHz)
*	1) CpuCLK=SysCLK
*	2) CpuClk=SysClk/2
*************************************************/
#define MCU_CPUCLK		(MCU_SYSCLK)
//#define MCU_CPUCLK		(MCU_SYSCLK/2)

#define TIMER_1T_1ms_TH	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(1000000)))) /256) 			
#define TIMER_1T_1ms_TL	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(1000000)))) %256)

#define TIMER_12T_1ms_TH	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(12000000)))) /256) 			
#define TIMER_12T_1ms_TL	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(12000000)))) %256)

#define TIMER_12T_10ms_TH	((65536-(u16)(float)(10000*((float)(MCU_SYSCLK)/12/(float)(1000000)))) /256) 			
#define TIMER_12T_10ms_TL	((65536-(u16)(float)(10000*((float)(MCU_SYSCLK)/12/(float)(1000000)))) %256)

#define LED_R		P32
#define LED_G_0		P33
#define LED_G_1		P46


#define PWM_MIN			(0*2)
#define PWM_MAX			(1000*2)
#define PWM_3_4			(750*2)
#define PWM_2_4			(500*2)
#define PWM_1_4			(250*2)
#define PWM_LOW			(60*2)
#define PWM_HINT		(80*2)

#define PCA_RELOAD		(PWM_MAX)

#define PCA_C           (65536)       	

#define PCA_CL(x)		(u8)((~(u16)x)+1) 
#define PCA_CH(x)     	(u8)(((~(u16)x)+1)>>8)         

idata WordTypeDef wDuty[2];
u8 uDutyTimecnt;

/*************************************************
*函数名称:     void DelayXus(u8 xUs)
*功能描述:   	延时程序，单位为us
*输入参数:     u8 Us -> *1us  (1~255)
*返回参数:     
*************************************************/
void DelayXus(u8 xUs)
{
	while(xUs!=0)
	{
#if (MCU_CPUCLK>=11059200)
		_nop_();
#endif
#if (MCU_CPUCLK>=14745600)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=16000000)
		_nop_();
#endif

#if (MCU_CPUCLK>=22118400)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=24000000)
		_nop_();
		_nop_();
#endif		
#if (MCU_CPUCLK>=29491200)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=32000000)
		_nop_();
		_nop_();
#endif

		xUs--;
	}
}

/*************************************************
*函数名称:     void DelayXms(u16 xMs)
*功能描述:     延时程序，单位为ms
*输入参数:     u16 xMs -> *1ms  (1~65535)
*返回参数:     
*************************************************/
void DelayXms(u16 xMs)
{
	while(xMs!=0)
	{
		CLRWDT();
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		xMs--;
		
	}
}

/***********************************************************************************
*函数名称:   void InitPort(void)
*功能描述:   IO配置
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitPort(void)
{
	PORT_SetP4PushPull(BIT6);						// 设置 P46为推挽输出
	PORT_SetP3PushPull(BIT0|BIT1|BIT2|BIT3);		// 设置P30,P31,P32,P33为推挽输出

	P10=1;
	PORT_SetP1OpenDrainPu(BIT0);					// 设置P10为开漏带上拉，用于控制输入
}

/***********************************************************************************
*函数名称:   void InitPCA_PWM(void)
*功能描述:   PWM初始化
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitPCA_PWM(void)
{
	PCA_SetCLOCK_SYSCLK();							// SYSCLK
	
	PCA_CH0_SetMode_PWM();
	PCA_CH1_SetMode_PWM();
	PCA_CH2_SetMode_PWM();
	PCA_CH3_SetMode_PWM();

	PCA_CH0_SetPWM_16Bit();
	PCA_CH1_SetPWM_16Bit();
	PCA_CH2_SetPWM_16Bit();
	PCA_CH3_SetPWM_16Bit();

	PCA_CH01_SetPWM_EnBufferMode();					// CH0,CH1 使能缓冲模式
	PCA_CH23_SetPWM_EnBufferMode();					// CH2,CH3 使能缓冲模式
	PCA_CH01_SetPWM_EnDeadTime();					// CH0,CH1 使能死区
	PCA_CH23_SetPWM_EnDeadTime();					// CH2,CH3 使能死区

	PCA_SetPWM_CenterAligned();						// 中心对齐
	PCA_SetCenterAligned_EnVar();					// 中心对齐下使能可变解析度
	PCA_SetCenterAligned_CFonTop();					// 中心对齐下CF在顶部置位

	PCA_SetDeadTimePreScaler_SysclkDiv8();			// 设置死区预分频 SysClk/8
	PCA_SetDeadTimePeriod(1);						// 设置死区时间 1*(1/PreScaler)=1*(1/(Sysclk/8))=8/Sysclk

	// 设置PWM占空比比较值
	PCA_CH0_SetValue(PCA_CH(PWM_MIN),PCA_CL(PWM_MIN));
	PCA_CH1_SetValue(PCA_CH(PWM_MIN),PCA_CL(PWM_MIN));
	PCA_CH2_SetValue(PCA_CH(PWM_MIN),PCA_CL(PWM_MIN));
	PCA_CH3_SetValue(PCA_CH(PWM_MIN),PCA_CL(PWM_MIN));

	// 设置PWM频率
	PCA_SetCounter(PCA_C-PCA_RELOAD);
	PCA_SetCounterReload(PCA_C-PCA_RELOAD);

	// 禁止PWM输出
	PCA_SetPWM0_DisOutput();					
	PCA_SetPWM1_DisOutput();
	PCA_SetPWM2_DisOutput();
	PCA_SetPWM3_DisOutput();

	PCA_SetCEX0CEX1CEX2CEX3_P30P33P31P46();			// 设置CEX0/CEX1/CEX2/CEX3引脚为P30P33P31P46

	PCA_CF_DisInterrupt();							// 禁止CF中断
	
	PCA_EnPCACounter();								// 使能PCA计数器, 
}

/***********************************************************************************
*函数名称:   void InitClock(void)
*功能描述:   时钟初始化	
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitClock(void)
{
#if (MCU_SYSCLK==8000000)
	// Default: IHRCO=16MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK/2
#endif

#if (MCU_SYSCLK==11059200)
	// IHRCO=22.12MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK/2
	CLK_SelIHRCO_22118400Hz();
#endif
	
#if (MCU_SYSCLK==16000000)
	// IHRCO=16MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK
	CLK_SetCKCON3(WDTCS_ILRCO|FWKP_NORMAL_120uS|MCKDO_MCK_DIV_1);
#endif

#if (MCU_SYSCLK==22118400)
	// IHRCO=22.12MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK
	CLK_SelIHRCO_22118400Hz();
	CLK_SetCKCON3(WDTCS_ILRCO|FWKP_NORMAL_120uS|MCKDO_MCK_DIV_1);
#endif
	

#if (MCU_CPUCLK==MCU_SYSCLK)
	CLK_SetCpuclk_Sysclk();
#else
	CLK_SetCpuclk_SysclkDiv2();
#endif

	// P45 输出 MCK/4
	//CLK_P45OC_MCKDiv4();
}

/***********************************************************************************
*函数名称:   void InitSystem(void)
*功能描述:   系统初始化
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitSystem(void)
{
	InitClock();
	InitPort();
	InitPCA_PWM();
}


void main()
{
	WordTypeDef duty;
	bit bOutFlag;
	
    InitSystem();

	wDuty[0].W=PWM_MIN;
	wDuty[1].W=PWM_2_4;
	bOutFlag=FALSE;
	
	while(1)
    {
    	DelayXms(10);
    	
		uDutyTimecnt++;
		if(uDutyTimecnt>=20)
		{
			uDutyTimecnt=0;
	    	LED_R=!LED_R;
		}
		if(bOutFlag==TRUE)
		{
			if(wDuty[0].W>=PWM_MAX)
			{
				wDuty[0].W=PWM_MIN;
			}
			else
			{
				wDuty[0].W=wDuty[0].W+16;
			}
			if(wDuty[1].W>=PWM_MAX)
			{
				wDuty[1].W=PWM_MIN;
			}
			else
			{
				wDuty[1].W=wDuty[1].W+16;
			}
			duty.W=PCA_C-wDuty[0].W;
			// 缓冲模式下,CH0/CH1的重载值寄存器为CH1的值
			PCA_CH1_SetValue(duty.B.BHigh,duty.B.BLow);
			duty.W=PCA_C-wDuty[1].W;
			// 缓冲模式下,CH2/CH3的重载值寄存器为CH3的值
			PCA_CH3_SetValue(duty.B.BHigh,duty.B.BLow);
		}
		
		if(P10==1)
		{
			if(bOutFlag==FALSE)
			{
				bOutFlag=TRUE;
				// 使能PWM输出
				PCA_SetPWM0_EnOutput(); 				
				PCA_SetPWM1_EnOutput();
				PCA_SetPWM2_EnOutput(); 				
				PCA_SetPWM3_EnOutput();
			}
		}
		else
		{
			if(bOutFlag==TRUE)
			{
				bOutFlag=FALSE;
				// 禁止PWM输出
				PCA_SetPWM0_DisOutput();					
				PCA_SetPWM1_DisOutput();
				PCA_SetPWM2_DisOutput();					
				PCA_SetPWM3_DisOutput();
			}
		}
    }
}


